   /*
  /*  Xi v1.0      by Glenn A. Waldron.
 /*  New UNIX Editor   Last Change: July 28, 1991. (Shell)
/*/

#include <stdio.h>
#include <sys/screen.h>
#include <string.h>
#include "gfr.h"

#define MAXDESK 10
#define MAXLINES 5000
#define MAXCLIP 1000
#define MAXLIM 256
#define NULL 0
#define TAB 0x09
#define BL ' '
#define BITPLNUM 32
#define TRUE 1
#define FALSE 0
#define HORIZ 7

#define HMNUM 15
char *hmsg[HMNUM] = {
"Xi 1.0   Commands:",
"                                  Alt - !     Open a Shell",
"F1          Help                  Alt - I     Insert line above crsr",
"F2          Save File             Alt - O     Open line below crsr",
"F3          File Menu             Alt - Del   Delete a line",
"F4          Information           Alt - M     Marker",
"F5          Desktop               Alt - T     Toggle Autoindent",
"F10         Exit                  Alt - S     Search",
"Arrows      Move cursor           Alt - N     Next Occurrence",
"Alt - <     Beginning of line     Alt - L     Jump To Line #",
"Alt - >     End of line           Alt - C     Clipboard Operations",
"Alt - [     Top of document       Alt - P     Paste",
"Alt - ]     Bottom of document    Alt - R     Report Status",
"Alt - A     Page up               Alt - U     Undo a line deletion",
"Alt - Z     Page down             Alt - V     Video adjust"
};

char undo[MAXLIM+1];

int LIM=0, SCRLINES=0, SLDIV2, fnine, desk=0, desknum=0;
int marklin[MAXDESK];
char *line[MAXDESK][MAXLINES];
char *desktop[MAXDESK];
int desklen[MAXDESK];
char *clipb[MAXCLIP], fn[35], findstr[41];
int tabnum=3, count[MAXDESK], topline, x=0, y=0, vx=0, dx=0, dy=0;
int curlin=0, indent=1, newfile=1, clipnum=0;
int quit=FALSE, tvar=0, superflag=1, oops, lnlen;
char stlnspa[MAXLIM];
int leftcol=0;

main(ac, av, ev)
int ac;
char *av[], *ev[];
{
  int len, i, c, code;
  FILE *fp;
  struct swinsize *swin;
  char *tpt;

  for (i=0; ev[i] != NULL; i++);
  for (c=0; c<i; c++) {
    len = strlen (ev[c]);
    if (len > 5) {
       if (! strncmp (ev[c], "LINES", 5))
          SCRLINES = atoi (&(ev[c][6]));
       else if (! strncmp (ev[c], "COLS", 4))
          LIM = atoi (&(ev[c][5]));
       }
    }
  if ((SCRLINES == 0) || (LIM == 0)) {
     swin = (struct swinsize *) malloc (sizeof (struct swinsize));
     ioctl (0, SIOCWINSIZE, swin);
     SCRLINES = swin->charsy - 2;
     LIM = swin->charsx;
     }
  SLDIV2 = SCRLINES / 2;
  if (SCRLINES % 2)
    SLDIV2++;
  lnlen = 30+(LIM-80);
  for (tpt = stlnspa, i = 0; i < lnlen; i++, tpt++)
    *tpt = ' ';
  *tpt = '\0';
  count[desk] = 0;
  for (i=0; i<MAXDESK; i++) marklin[i] = 0;
  if (ac > 2) {
    printf("Error!   Usage:  xi <filename>\n\n");
    exit(0);
    }
  c_direct_io();
  while (newfile) {
    oops = 0;
    newfile = 0;
    quit = 0;
    if (opening(ac, av[1]) == -1) {
      c_normal_io();
      exit (0);
      }
    if (! oops)
      topline = curlin = x = vx = y = 0;
    annihilate (findstr, 40);
    while (! quit) {
      printat (topline);
      jump(y,vx);
      code = editor();
      switch (code) {
        case 0:
          quit = 1;
          dialog (7, 40, SLDIV2-(5/2), (LIM-40)/2);
          goprintw (2, 3, "There");
          if (desknum == 1)
            goprintw (2, 9, "is 1 file on the desktop.");
          else
            goprintfw (2, 9, "are %d files on the desktop.", desknum);
          goprintw (4, 3, "Are you sure you want to quit?");
          if (toupper (getchar()) != 'Y')
            quit = 0;
          printat (topline);
          break;
        case 1: savefile();
          break;
        case 2: newfile = filemenu();
          if (newfile) {
            quit = TRUE;
            ac = 1; av[1] = NULL;
            }
          break;  
        }
      }
    }
  c_normal_io();
  fflush (stdin);
  jump(SCRLINES+1,0);
  putchar('\n');
}  



int editor()
{
  char c;
  int len, vlen, i;

  quit = FALSE;
  while (! quit) {
    line[desk][count[desk]] = NULL;
    jump(y,vx); 
    c = getchar();
    switch ((unsigned char) c) {
    case 0x9b:
      switch (getchar()) {
        case 'A': movecup (); break;
        case 'B': movecdn (); break;
        case 'C': len = strlen(line[desk][curlin]);
          if (x < len-1)
            vx = (++x) - leftcol;
          if (vx > LIM-HORIZ) {
            vx = LIM-HORIZ;
            leftcol++;
            printat (topline);
            }
          break;
        case 'D': len = strlen(line[desk][curlin]);
          if (x > 0)
            vx = (--x) - leftcol;
          if ((leftcol) && (vx < HORIZ)) {
            vx = HORIZ;
            leftcol--;
            printat (topline);
            }
          break;
        case 0x30:getchar(); helpscr(); break;
        case 0x31:getchar(); return(1);
        case 0x32:getchar(); return(2);
        case 0x33:getchar(); information(); break;
        case 0x34:getchar(); queue(); break;
        case 0x38:getchar(); fnine = 1; return(0);
        case 0x39:getchar(); return(0);
        }
      break;
    case 0xa1:               /* alt-! */
    case 0xb1:               /* alt-1 */
      shellwin ();
      break;
    case TAB:                /* TAB key */
      for (i=0; i<tabnum; i++) {
        len = strlen(line[desk][curlin]);
        cins (line[desk][curlin], BL);
        }
      break;
    case 0x7f:               /* del */
      cdel (line[desk][curlin], 0);
      break;
    case 0x08:               /* <- */
      cdel (line[desk][curlin], 1);
      break;
    case 0xff:               /* alt-del */
      ldel (); break;
    case 0x0a:               /* <cr> */
      carraige(); break;
    case 0xcc: case 0xec:    /* alt-L */
      gotoln(); break;
    case 0xd6: case 0xf6:    /* alt-K */
      video(); break;
    case 0xf4: case 0xd4:    /* alt-T */
      indent = 1-indent; break;
    case 0x10:               /* ctl-P */
      c_normal_io();
      jump(SCRLINES+1,0);
      putchar ('\n');
      exit (0);
      break;
    case 0xc1: case 0xe1:    /* alt-A */
      pageup(); break;
    case 0xda: case 0xfa:    /* alt-Z */
      pagedn(); break;
    case 0xe0: case 0xfe:    /* alt-` */
      fiveup(); break;
    case 0x89:               /* alt-TAB */
      fivedn(); break;
    case 0xac: case 0xbc:    /* alt-< */
      x = 0; vx = 0; len = leftcol; leftcol=0;
      if (len != leftcol)
        printat (topline);
      break;
    case 0xe9: case 0xc9:    /* alt-I */
      lins (0); break;
    case 0xef: case 0xcf:    /* alt-O */
      lins (1); break;
    case 0xd2: case 0xf2:    /* alt-R */
      reportstats(); break;
    case 0xd3: case 0xf3:    /* alt-S */
      whereisit (0); break;
    case 0xd5: case 0xf5:    /* alt-U */
      if (*undo) undoit();
      break;
    case 0xcd: case 0xed:    /* alt-M */
      marker(); break;
    case 0xce: case 0xee:    /* alt-N */
      whereisit (1); break;
    case 0xc3: case 0xe3:    /* alt-C */
      clipboard (0); break;
    case 0xf0: case 0xd0:    /* alt-P */
      clipboard (1); break;
    case 0xae: case 0xbe:    /* alt-> */
      x = strlen(line[desk][curlin])-1;
      leftcol = 0;
      if ((x - LIM) > 0) {
        leftcol = x - LIM + HORIZ;
        printat (topline);
        }
      vx = x - leftcol;
      break;
    case 0xdb:      /* alt-[ */
      curlin = 0; topline = 0;
      x = 0; vx = 0; y = 0; leftcol = 0;
      printat (0); break;
    case 0xdd:      /* alt-] */
      curlin = count[desk]-1;
      topline = (count[desk] > SCRLINES+1) ? count[desk]-SCRLINES-1 : 0;
      x = 0; vx = 0;
      y = (count[desk] > SCRLINES+1) ? SCRLINES : count[desk]-1;
      leftcol = 0;
      printat (topline); break;
    default:
      if (gisprint(c)) {
        len = strlen(line[desk][curlin]);
        cins (line[desk][curlin], c);
        }
      }
    }
}


int gisprint(ch)
unsigned char ch;
{
  return ((ch < 128) && (ch > 31));
}

clipboard(code)
int code;
{
  char *cliplist[4] = { " Cut ", " Copy ", " Paste ", " Cancel " };
  int cursav, indsave, cliptop, clipbot, cliplin, k=3, i, j, len;
  char c=0, c2=0;

  if (!code) {
    dialog (8, 15, SLDIV2-(8/2), (LIM-15)/2);
    goprintw (1, 2, "Clipboard");
    k = menu (3, 1, 1, 13, cliplist, 4);
    }
  if ((k==4) || (k==0)) { printat (topline); return; }
  switch (k) {
  case 1:
    if (count[desk] == 1) { printat (topline); return; }
  case 2:
    printat (topline);
    x = 0; vx = 0; leftcol = 0;
    INVERSE;
    len = strlen(line[desk][curlin]);
    if (len > LIM) len = LIM;
    goprintn (y, 0, line[desk][curlin], len-1);
    cliptop = clipbot = cliplin = cursav = curlin;
    while ( (c = getchar()) != '\n') {
      if ((unsigned char) c == 0x9b) {
        switch (c2 = getchar()) {
        case 'A': if (cliplin) {
            cliplin--;
            if (cliplin >= cursav) {
              clipbot--;
              NORMAL;
              len = strlen(line[desk][curlin]);
              if (len > LIM) len = LIM;
              goprintn (y, 0, line[desk][curlin], len-1);
              }
            else cliptop--;
            movecup ();
            INVERSE;
            len = strlen(line[desk][curlin]);
            if (len > LIM) len = LIM;
            goprintn (y, 0, line[desk][curlin], len-1);
            }
            break;
        case 'B': if (cliplin < count[desk]-1) {
            cliplin++;
            if (cliplin <= cursav) {
              cliptop++;
              NORMAL;
              len = strlen(line[desk][curlin]);
              if (len > LIM) len = LIM;
              goprintn (y, 0, line[desk][curlin], len-1);
              }
            else clipbot++;
            movecdn ();
            INVERSE;
            len = strlen(line[desk][curlin]);
            if (len > LIM) len = LIM;
            goprintn (y, 0, line[desk][curlin], len-1);
            }
            break;
        }  /* switch */
        }  /* if */
      }    /* while */
    for (i=0; i<clipnum; i++)
      free (clipb[i]);
    clipnum=0;
    for (i=cliptop; i<=clipbot; i++) {
      clipb[clipnum] = (char *) malloc ( (MAXLIM+1) * sizeof(char) );
      strcpy (clipb[clipnum++], line[desk][i]);
      }
    curlin = cliptop;
    topline = (curlin > SLDIV2 ) ? curlin-SLDIV2 : 0;
    y = (topline == 0) ? curlin : SLDIV2;
    NORMAL;
    printat (topline);
    if (k == 1) {
      for (i=0; i<clipnum; i++)
        ldel();
      }
    break;
  case 3:
    printat (topline);
    indsave = indent;
    indent = 0;
    for (i=0; i<clipnum; i++) {
      lins (1);
      strcpy (line[desk][curlin], clipb[i]);
      }
    indent = indsave;
    break;
  }
  NORMAL;
  printat (topline);
}



whereisit(code)
int code;
{
  int savey, savex, tempx, findlen, len, lc, notfnd=1, global=0, replace=0;
  int savetop, replen, k, i, vlen, verify, veryes=1;
  char str1[41], repstr[41], vch;
  char *smenu[5] = { " Search ", " Replace ", " Global Search & Replace ",
    " Global Verify & Replace ", " Cancel " };

  savey = y;
  savetop = topline;
  switch (code) {
  case 0:
    annihilate (findstr, 40);
    annihilate (repstr, 40);
    dialog (9, 30, SLDIV2-(8/2), (LIM-30)/2);
    goprintw (1, 2, "Search Menu");
    k = menu (3, 2, 1, 28, smenu, 5);
    if ( (k == 5) || (k == 0) ) {
      printat (topline); return; }
    replace = (k > 1);
    global = (k > 2);
    verify = (k > 3);
    dialog (3+replace, 60, 3, (LIM-60)/2);
    goprintw (1, 2, "Search String: ");
    strin (findstr, 40);
    if (*findstr == NULL) {
      printat (topline); return; }
    if (replace) {
      goprintw (2, 2, "Replace String: ");
      strin (repstr, 40);
      if (*repstr == NULL) {
        printat (topline); return;
        }
      replen = strlen (repstr);
      }
    if (global) {
      x = 0; vx = 0; leftcol=0; }
    printat (topline);
  case 1:
  annihilate (str1, 41);
  findlen = strlen(findstr);
  if (findlen) {
    savex = x;
    tempx = x+1;
    lc = curlin;
    do {
      len = strlen (line[desk][lc]);
      vlen = len - leftcol;
      while ( (findlen <= len-tempx-1) && notfnd ) {
        if (verify) veryes = 0;
        strncpy (str1, &line[desk][lc][tempx], findlen);
        notfnd = strcmp (str1, findstr);
        if ( (! notfnd) && replace) {
          if (verify) {
            leftcol = tempx - LIM + HORIZ;
            if (findlen > HORIZ) leftcol += (findlen - HORIZ);
            if (leftcol < 0) leftcol = 0;
            vx = tempx - leftcol;
            topline = (lc > SLDIV2) ? lc-SLDIV2 : 0;
            y = (topline == 0) ? lc : SLDIV2;
            printat (topline);
            jump(y,vx);
            INVERSE;
            printf ("%s", findstr);
            NORMAL;
            dialog (3, 25, SLDIV2+4, (LIM/2)+10);
            goprintw (1, 2, "Replace? (y/n/esc): ");
            vch = getchar ();
            veryes = (toupper (vch) == 'Y');
            if (!veryes) {
              printat (topline);
              }
            notfnd = global;
            if (vch == ESC) {
              notfnd = 0;
              global = 0;
              }
            }
          if (veryes) {
            if (vlen+replen-findlen <= MAXLIM) {
              x = tempx;
              for (i=0; i < findlen; i++)
                cdel (line[desk][lc], 0);
              for (i=0; i < replen; i++)
                cins (line[desk][lc], repstr[i]);
              tempx = x;
              notfnd = global;
              if (verify) {
                printat (topline);
                }
              }
            else {
              dialog (3, 40, SLDIV2-(3/2), (LIM-40)/2);
              goprintw (1, 2, "Line too long to replace! Continue?");
              vch = getchar();
              if (toupper (vch) == 'N') {
                notfnd = 0;
                global = 0;
                }
              }
            }
          }
        tempx++;
      }
      lc = (lc == count[desk]-1) ? 0 : lc+1;
      if (notfnd) tempx = 0;
    } while ( (notfnd) && (lc != curlin) );
    if (! notfnd) {
      curlin = (lc == 0) ? count[desk]-1 : lc-1;
      x = tempx-1;
      leftcol = x - LIM + HORIZ;
      if (leftcol < 0) leftcol = 0;
      vx = x - leftcol;
      topline = (curlin > SLDIV2) ? curlin-SLDIV2 : 0;
      y = (topline == 0) ? curlin : SLDIV2;
      }
    else {
      y = savey;
      topline = savetop;
      x = savex;
      leftcol = x - LIM + HORIZ;
      if (leftcol < 0) leftcol = 0;
      vx = x - leftcol;
      }
    }
  } /* switch */
  printat (topline);
}

gotoln()
{
  char str[5];
  int lin;

  annihilate (str, 5);
  dialog (3, 20, SLDIV2-(3/2), (LIM-20)/2);
  goprintw (1, 2, "Goto Line: ");
  strin(str, 4);
  if (*str) {
    lin = atoi (str);
    if (lin) {
      lin = (lin > count[desk]) ? count[desk] : lin;
      curlin = lin-1;
      topline = (curlin > SLDIV2 ) ? curlin-SLDIV2 : 0;
      x = 0; vx = 0; leftcol = 0;
      y = (topline == 0) ? curlin : SLDIV2;
      }
    }
  printat (topline);
}

marker()
{
  char *memch[3] = { " Recall Marker ", " Set Marker ", " Cancel " };
  int k;
  
  dialog (5, 19, SLDIV2-(5/2), (LIM-17)/2);
  k = menu (1, 1, 3, 17, memch, 3);
  switch (k) {
    case 0:
    case 3:
      printat (topline);
      return;
    case 1:
      curlin = marklin[desk];
      x = 0; vx = 0; leftcol = 0;
      remakesc();
      return;
    case 2:
      marklin[desk] = curlin;
      printat (topline);
      return;
    }
}
  

carraige()
{
  char tmp[MAXLIM+1], *tmpptr;
  int tempx, i, len;

  tvar = 0;
  annihilate (tmp, MAXLIM+1);
  tempx = x;
  len = strlen(line[desk][curlin]);
  if (tempx != len-1) tvar = 1;
  lins(1);
  if (tempx != len-1) {
    strncpy (tmp, &line[desk][curlin-1][tempx], len-tempx);
    for (i=0; (tmp[i] == TAB) || (tmp[i] == BL); i++);
    tmpptr = &tmp[i];
    strcpy (&line[desk][curlin][x], tmpptr);
    line[desk][curlin][x+len-tempx] = NULL;
    line[desk][curlin-1][tempx] = '\n';
    line[desk][curlin-1][tempx+1] = NULL;
    len = strlen(line[desk][curlin]);
    if ( (len > 1) && (tempx == 0) )
      vx = x - leftcol;
    }
  printat (topline);
}


reportstats()
{
  int i;

  char *onoff[2] = { "OFF", "ON" };
  char *stuff[6] = { "Lines:", "Current:", "Tab Stops:", "Clipboard:",
    "AutoIndent:", "Marker:" };

  dialog (10, 30, SLDIV2-(11/2), (LIM-30)/2);
  for (i=0; i<6; i++)
    goprintw (i+3, 2, stuff[i]);
  goprintw (1, 2, desktop[desk]);
  goprintfw (3, 9, "%d", count[desk]);
  goprintfw (4, 11, "%d", curlin+1);
  goprintfw (5, 13, "%d", tabnum);
  goprintfw (6, 13, "%d", clipnum);
  goprintw (7, 14, onoff[indent]);
  goprintfw (8, 10, "%d", marklin[desk]+1);
  waitfor (8, 28);
  printat (topline);
}



remakesc()
{
  topline = (curlin > SLDIV2 ) ? curlin-SLDIV2 : 0;
  x = 0; vx = 0; leftcol = 0;
  y = (topline == 0) ? curlin : SLDIV2;
  printat (topline);
}



fiveup()
{
  curlin = (curlin-5 < 0) ? 0 : curlin-5;
  remakesc();
}

fivedn()
{
  curlin = (curlin+5 > count[desk]-1) ? count[desk]-1 : curlin+5;
  remakesc() - HORIZ;
}

pageup()
{
  curlin = (curlin-(SCRLINES-3) < 0) ? 0 : curlin-(SCRLINES-3);
  remakesc();  
}



pagedn()
{
  curlin = (curlin+SCRLINES-3 > count[desk]-1) ?
    count[desk]-1 : curlin+SCRLINES-3;
  remakesc();
}


movecup()
{
  int len, len2, please, oldleft;
  char *lsp;

  if (curlin > 0) {
    please = FALSE;
    len = strlen(line[desk][--curlin]);
    if (y) y--;
    else {
      --topline;
      printf ("\033[H\033[L");
      lsp = line[desk][curlin] + leftcol;
      len2 = strlen (lsp);
      if (len2 > LIM) len2 = LIM;
      printn (lsp, len2-1);
      }
    if (x > len-1) {
      x = len-1;
      if ((len-1 - HORIZ) < leftcol) {
        oldleft = leftcol;
        leftcol = len-1 - HORIZ;
        if (leftcol < 0)
          leftcol = 0;
        if (leftcol != oldleft)
          please = TRUE;
        }
      }
    vx = x - leftcol;
    if (please)
      printat (topline);
    else
      statline ();
    }
}


movecdn()
{
  int len, len2, j, please, oldleft;
  char tmp[MAXLIM+1], *lsp;

  if (curlin < count[desk]-1) {
    please = FALSE;
    len = strlen(line[desk][++curlin]);
    if (y < SCRLINES) y++;
    else {
      ++topline;
      putchar ('\n');
      putchar ('\n');
      jump(SCRLINES,0);
      CLEOL;
      lsp = line[desk][curlin] + leftcol;
      len2 = strlen (lsp);
      printn (lsp, len2-1);
      }
    if (x > len-1) {
      x = len-1;
      if ((len-1 - HORIZ) < leftcol) {
        oldleft = leftcol;
        leftcol = len-1 - HORIZ;
        if (leftcol < 0)
        leftcol = 0;
        if (leftcol != oldleft)
          please = TRUE;
        }
      }
    vx = x - leftcol;
    if (please)
      printat (topline);
    else
      statline ();
    }
}


int cmpos(str)
char *str;
{
  int i, tpos;

  for (x=0, i=0; i<vx; i++, x++)
    if (str[x] == TAB) {
      tpos = (i % tabnum);
      if (tpos == 0) i += (tabnum);
      else i += tabnum-tpos;
      i--;
      }
}


ldel()
{
  int i, len;
 
  annihilate (undo, MAXLIM+1);
  strcpy (undo, line[desk][curlin]);
  if (count[desk] == 1) {
    line[desk][count[desk]] = NULL;
    annihilate (line[desk][curlin], MAXLIM+1);
    line[desk][curlin][0] = '\n';
    line[desk][curlin][1] = NULL;
    x = 0; vx = 0; leftcol = 0;
    printat (topline);
    }
  else {
    free (line[desk][curlin]);
    line[desk][count[desk]] = NULL;
    for (i = curlin; i < count[desk]-1; i++)
      line[desk][i] = line[desk][i+1];
    if (curlin == --count[desk]) {
      curlin--;
      if (y > 0) y--;
      else printat (--topline);
      }
    line[desk][count[desk]] = NULL;
    x = 0; vx = 0; leftcol = 0;
    printf ("\033[M");
    if (marklin[desk] > curlin) marklin[desk]--;
    else if (marklin[desk] == curlin) marklin[desk] = 0;
    if (topline+SCRLINES < count[desk]) {
      len = strlen(line[desk][topline+SCRLINES]);
      jump(SCRLINES,0);
      CLEOL;
      printn (line[desk][topline+SCRLINES], len-1);
      }
    else {
      jump(SCRLINES,0);
      CLEOL;
      }
    }
  statline ();
}


lins(code)
int code;
{
  int i;

  line[desk][count[desk]] = NULL;
  for (i=count[desk]; i > curlin+code; i--)
    line[desk][i] = line[desk][i-1];
  count[desk]++;
  curlin += code;
  line[desk][curlin] = (char *) malloc ( (MAXLIM+1) * sizeof(char));
  line[desk][curlin][0] = '\n';
  line[desk][curlin][1] = NULL;
  if (code == 1) {
    if (y == SCRLINES)
      topline++;
    else y++;
    }
  line[desk][count[desk]] = NULL;
  x = 0; vx = 0; leftcol = 0;
  if ( indent && curlin ) {
    for (x=0; (line[desk][curlin-1][x] == BL); x++) {
      line[desk][curlin][x] = BL;
      line[desk][curlin][x+1] = '\n';
      line[desk][curlin][x+2] = NULL;
      }
    vx = x - leftcol;
    }
  if (y < SCRLINES) {
    jump(y,vx);
    printf ("\033[L");
    }
  else if (tvar == 0) {
    printat (topline);
    }
  if (marklin[desk] > curlin) marklin[desk]++;
  else if (marklin[desk] == curlin) marklin[desk] += (1-code);
  statline ();
}


cins(str, c)
char *str, c;
{
  int i, len;
  char *lsp;

  len = strlen(str);
  for (i=len+1; i>=x; i--)
    str[i+1] = str[i];
  str[x++] = c;
  vx = x - leftcol;
  if (vx > LIM-HORIZ) {
    jump(y,0);
    vx--;
    leftcol++;
    printat (topline);
    }
  else
    printf ("\033[1@%c", c);
}



cdel(str, code)
char *str;
int code;
{
  int len, i, vpos, len2, vlen2, vlen, islast, tempcl, please;
  char *lsp;
  
  please = FALSE;
  len = strlen (str);
  switch (code) {
  case 0:  if ( (len != 0) && (x != len-1) ) {
      printf ("\033[1P");
      for (i=x; i<=len; i++)
        str[i] = str[i+1];
      str[i+1] = NULL;
      }
    break;
  case 1:  if ( (len == 1) && curlin ) {
      tempcl = curlin;
      ldel();  
      islast = (curlin != tempcl);
      if (! islast) curlin--;
      x = strlen(line[desk][curlin]) - 1;
      vx = x - leftcol;
      if ( (y==0) && (! islast) ) topline--;
      else if (! islast) y--;
      printat (topline);
    }
    else if ( (len > 1) && (x == 0) && curlin) {
      len2 = strlen(line[desk][curlin-1]);
      vlen = len - leftcol;
      vlen2 = len2 - leftcol;
      if ( (vlen + vlen2 - 2) < MAXLIM ) {
        line[desk][curlin-1][len2-1] = NULL;
        strcat (line[desk][curlin-1], line[desk][curlin]);
        tempcl = curlin;
        ldel();
        islast = (curlin != tempcl);
        if (! islast) curlin--;
        x = len2-1;
        leftcol = x - LIM + HORIZ;
        if (leftcol < 0)
          leftcol = 0;
        vx = x - leftcol;
        if ( (y == 0) && (! islast) ) topline--;
        else if (! islast) y--;
        printat (topline);
        }
    }
    else if (x > 0) {
      vx = (--x) - leftcol;
      if ((vx < HORIZ) && leftcol)
        please = TRUE;
      putchar ('\b');
      cdel (str, 0);
      }
    break;
  }
  if (please) {
    vx++;
    leftcol--;
    printat (topline);
    }
  else {
    jump(y,0);
    lsp = line[desk][curlin] + leftcol;
    len = strlen (lsp);
    if (len > LIM) len = LIM;
    printn (lsp, len-1);
    if (len < LIM)
      CLEOL;
    }
}


opening(arc, arg)
int arc;
char *arg;
{
  char c, tmpstr[MAXLIM];
  int i=0, len, vlen, desksav;
  FILE *fp;

  CLS;
  if (arc == 1) {
    dialog(8, 60, SLDIV2-(8/2), (LIM-60)/2);
    goprintw (2, 16, "Xi Editor  by Glenn Waldron");
    goprintw (3, 16, "   Version 1.0  11/6/90");
    goprintw (5, 7, "File --> ");
    strin(fn, 28);
    }
  else strcpy (fn, arg);
  if (fn[0] == NULL) {
    if (superflag) {
      quit = 1;
      newfile = 0;
      }
    else {
      oops = 1;
      return (0);
      }
    }
  else
  if (fp = fopen(fn, "r")) {
    if (arc == 1) {
      goprintw (5, 7, "Loading:");
      goprintw (5, 16, fn);
      }
    superflag = 0;
    len = strlen (fn);
    desksav = desk;
    desk = desknum++;
    desktop[desk] = (char *) malloc (len * sizeof (char));
    annihilate (desktop[desk], len);
    desklen[desk] = len;
    strcpy (desktop[desk], fn);
    while ( (! feof(fp)) && (i <= MAXLINES) ) {
      fgets (tmpstr, MAXLIM, fp);
      len = strlen (tmpstr);
      vlen = len - leftcol;
      if (vlen < MAXLIM) {
        line[desk][i] = (char *) malloc (MAXLIM * sizeof(char));
        strcpy (line[desk][i++], tmpstr);
        }
      else {
        jump(SCRLINES,0);
        putchar ('\n');
        printf ("Line too long (%d).\n", i);
        fclose (fp);
        _exit (0);
        }
      }
    fclose (fp);
    count[desk] = i-1;
    }
  else {
    if (arc == 1) {
      goprintw (5, 7, "New File:");
      }
    desk = desknum++;
    len = strlen (fn);
    desktop[desk] = (char *) malloc (len * sizeof (char));
    annihilate (desktop[desk], len);
    desklen[desk] = len;
    strcpy (desktop[desk], fn);
    line[desk][0] = (char *) malloc (MAXLIM * sizeof(char));
    line[desk][0][0] = '\n';
    line[desk][0][1] = NULL;
    count[desk] = 1;
    }
}


savefile()
{
  FILE *fp;
  int i;

  dialog(5, 27, 0, 0);
  goprintw (2, 3, "Saving File...");
  fflush (stdout);
  if (fp = fopen(desktop[desk], "w")) {
    for (i=0; (i < count[desk]) && (line[desk][i] != NULL); i++)
      fputs (line[desk][i], fp);
    fclose (fp);
    goprintw (2, 17, "Done!");
    }
  else {
    goprintw (2, 17, "Error!");
    waitfor (2, 24);
    }
}


printat(i)
int i;
{
  int j, len;
  char *lsp;
  
  jump(0,0);
  for (j=i; j<=i+SCRLINES; j++) {
    if (j == count[desk]) {
      j = i+SCRLINES;
      printf ("\033[J");
      }
    else {
      if (j+1 <= i+SCRLINES) {
        len = strlen (line[desk][j]);
        if (len > leftcol) {
          lsp = line[desk][j] + leftcol;
          len = strlen (lsp);
          if (len <= LIM)
            printn (lsp, len-1);
          else printn (lsp, LIM);
          }
          CLEOL;
        putchar ('\n');
        }
      else {
        CLEOL;
        len = strlen(line[desk][j]);
        if (len > leftcol) {
          lsp = line[desk][j] + leftcol;
          len = strlen (lsp);
          if (len <= LIM)
            printn (lsp, len-1);
          else printn (lsp, LIM);
          }
        }
      }
    }
  statline ();
}

strin(str, maxlen)
char *str;
int maxlen;
{
  char c;
  int j, i=-1;

  str[0] = NULL;
  while ( (c = getchar()) != '\n') {
    if ( (i < maxlen-1) && (isprint(c)) ) {
      str[++i] = c;
      str[i+1] = NULL;
      putchar (c);
      }
    if (c == 0x08) {
      if (i > -1) {
        str[i--] = NULL;
        printf ("\b \b");
        }
      }
    }
}


annihilate (str, len)
char *str;
int len;
{
  int i;

  for (i=0; i<len; i++)
    str[i] = NULL;
}


helpscr()
{
  int i;

  dialog (HMNUM+2, 75, SLDIV2-((HMNUM+2)/2), (LIM-75)/2);
  for (i=0; i<HMNUM; i++)
    goprintw (i+1, 2, hmsg[i]);
  waitfor (1, 70);
  printat(topline);
}


chfilename()
{
  char str[35];
  int len;

  annihilate (str, 34);
  dialog (3, 70, 0, (LIM-70)/2);
  goprintw (1, 2, "Enter new filename or <cr> to cancel -> ");
  strin (str, 32);
  if (str[0] != NULL) {
    free (desktop[desk]);
    len = strlen (str);
    desktop[desk] = (char *) malloc (len * sizeof (char));
    strcpy (desktop[desk], str);
    desklen[desk] = len;
    }
  printat(topline);
}


filemenu()
{
  int c, retval;
  char *choices[4] = { " Save File ", " Change File Name ",
    " Add a File to Desktop ", " Return to Editor " };

  do {
    dialog (8, 30, SLDIV2-(8/2), (LIM-30)/2);
    goprintw (1, 2, "File: ");
    goprintw (1, 8, desktop[desk]);
    c = menu (3, 2, 1, 28, choices, 4);
    switch (c) {
      case 1: savefile(); break;
      case 2: chfilename(); break;
      case 3: if (desknum < MAXDESK)
        retval = 1;
        else retval = 0; break;
      case 0:
      case 4: retval = 0; break;
      }
    } while (c < 3);
  printat (topline);
  return (retval);
}    


information()
{
  int i;

  dialog (7, 31, SLDIV2-(7/2), (LIM-30)/2);
  goprintw (2, 3, "Xi Editor   Version 1.0");
  goprintw (4, 3, "by Glenn Waldron 12/1/90");
  waitfor (4, 28);
  printat (topline);
}

undoit()
{
  if (curlin == count[desk]-1)
    lins (1);
  else lins (0);
  strcpy (line[desk][curlin], undo);
  x = 0; vx = 0; leftcol = 0;
  printat (topline);
}

queue()
{
  int k, desksav;

  dialog (5+desknum, 40, SLDIV2-((5+desknum)/2), (LIM-40)/2);
  goprintw (1, 2, "Files on the desktop:");
  goprintfw (desk+3, 1, "%c%c%c", scson, 0x60, scsoff);
  desksav = desk;
  k = menu (3, 3, 1, 38, desktop, desknum);
  if (k) {
    desk = k-1;
    if (desk != desksav)
      x = vx = y = curlin = topline = 0;
    }
  printat (topline);
}

video()
{
  unsigned char c;
  int cx=0, i, plane=0;
  unsigned char oc[3][32], el[3];
  struct scolor hue[BITPLNUM];
  
  dialog (7, 30, SLDIV2-(7/2), (LIM-30)/2);
  ioctl (0, SIOCGETCMAP, hue);
  el[0] = hue[plane].red;
  el[1] = hue[plane].green;
  el[2] = hue[plane].blue;
  for (i=0; i<BITPLNUM; i++) {
    oc[0][i] = hue[i].red;
    oc[1][i] = hue[i].green;
    oc[2][i] = hue[i].blue;
    }
  goprintw (1, 2, "Use arrows to set color.");
  goprintw (2, 2, "r = reset    <cr> = done");
  while (cx != -1) {
    goprintfw (4, 10, "Plane: %d", plane);
    goprintw (4, 2, "R G B");
    hue[plane].red = el[0];
    hue[plane].green = el[1];
    hue[plane].blue = el[2];
    goprintfw (5, 2, "%x %x %x",
      hue[plane].red/16, hue[plane].green/16, hue[plane].blue/16);
    ioctl (0, SIOCSETCMAP, hue);
    move(5, 2+(cx*2));
    c = getchar();
    switch (c) {
      case 0x9b:
        switch (c = getchar()) {
          case 'A':
            el[cx] += (el[cx] == 0x0F)? -255 : 15;
            break;
          case 'B':
            el[cx] -= (el[cx] == 0)? -255 : 15;
            break;
          case 'C':
            cx += (cx == 2)? -2 : 1;
            break;
          case 'D':
            cx -= (cx == 0)? -2 : 1;
            break;
          }
        break;
      case 'b':
        move(4, 20);
        c = 0;
        while (! isdigit (c))
          c = getchar();
        putchar(c);
        plane = c & 0x0F;
        break;
      case 'r':
        for (plane=BITPLNUM-1; plane>=0; plane--) {
          goprintfw (4, 10, "Bitplane: %d", plane);
          goprintw (4, 2, "R G B");
          hue[plane].red = oc[0][plane];
          hue[plane].green = oc[1][plane];
          hue[plane].blue = oc[2][plane];
          goprintfw (5, 2, "%x %x %x",
            hue[plane].red/16, hue[plane].green/16, hue[plane].blue/16);
          ioctl (0, SIOCSETCMAP, hue);
          }
        plane = 0;
        el[0] = oc[0][plane];
        el[1] = oc[1][plane];
        el[2] = oc[2][plane];
        break;
      case 0x0a:
      case ESC:
        printat (topline);
        return;
        break;
      }
    }
}

statline()
{
  jump (SCRLINES+1,0);
  INVERSE;
  printf (" Line: %4d   Total: %4d    Marker: %4d    File:",
    curlin+1, count[desk], marklin[desk]+1);
  printf ("%s\033[%d;52H%s", stlnspa, SCRLINES+2, desktop[desk]);
  NORMAL;
}


byebye ()
{
  c_normal_io ();
  _exit (0);
}


shellwin()
{
  char str[MAXLIM];
 
  CLS;
  jump(0,0);
  puts ("UNIX Shell");
  puts ("Type \\quit or \\exit to return to XI.");
  puts ("Type \\help for a list of XI commands.\n");
  for (;;) {
    putchar ('>');
    strin (str, LIM-1);
    putchar ('\n');
    putchar ('\n');
    if (str[0] == '\\') {
      if ( (! strcmp (&str[1], "exit")) || (! strcmp (&str[1], "quit")) ) {
        CLS;
        printat (topline);
        return;
        }
      else if (!strcmp (&str[1], "help"))
        shelp ();
      else if (!strcmp (&str[1], "cls"))
         CLS;
      }
    else
      system (str);
    }
}  


shelp()
{
  puts ("Xi UNIX Shell Enviroment Commands");
  puts ("---------------------------------");
  puts ("\\quit, \\exit   Return to Xi Editor");
  puts ("\\help      Print this help screen");
  puts ("\\cls      Clear the screen");
}
